%
% Ponto de Bolha (bubble point):
% 
% Ref: Henley e Seader 
%      pag 282

clear all
clc
close all
warning off

%Valores especificados:
Tfvetor=200:1:240;  % temperatura de flash (Farenheit)
Tfvetor=Tfvetor';

z1=0.10;  % composicao da alimentacao
z2=0.20;  % composicao da alimentacao
z3=0.30;  % composicao da alimentacao


% Inicializando parametros
i=1;
Pvetor=[];
Yvetor=[];


% Loop para cada temperatura:
while (i<=length(Tfvetor)),
    
    %Parametros para a funcao
    Tf=Tfvetor(i);
    par=[Tf, z1, z2, z3];

    Pfinal = fzero('fncex2', 700, [],par);
    
    load resultado
    Yvetor=[Yvetor; Y];
    Pvetor=[Pvetor; Pfinal]; %em psia

    i=i+1;
end

figure(1)
plot(Tfvetor,Pvetor,'-r')
title('Ponto de Bolha')
xlabel('Temperatura (Farenheit)')
ylabel('Pressao (psia)')
line([200,240],[420,420])


figure(2)
plot(Tfvetor,Yvetor(:,1),'-b')
hold on
plot(Tfvetor,Yvetor(:,2),'-r')
plot(Tfvetor,Yvetor(:,3),'-k')
plot(Tfvetor,Yvetor(:,4),'-y')
xlabel('Temperatura (Farenheit)')
ylabel('Composicao')
legend('Comp 1','Comp 2', 'Comp 3', 'Comp 4')