%
% Ponto de Orvalho (dew point):
% 
% Ref: Henley e Seader 
%      pag 283

clear all
close all
clc
warning off

%Valores especificados:
Tfvetor=200:1:400;  % temperatura (Farenheit)
Tfvetor=Tfvetor';
z1=0.10;  % composicao da alimentacao
z2=0.20;  % composicao da alimentacao
z3=0.30;  % composicao da alimentacao


% Inicializando parametros
i=1;
Pvetor=[];
Xvetor=[];


% Loop para cada temperatura:
while (i<=length(Tfvetor)),

    %Parametros para a funcao
    Tf=Tfvetor(i);
    par=[Tf, z1, z2, z3];

    Pfinal = fzero('fncex3', 700, [],par);
    
    load resultado
    Xvetor=[Xvetor; X];
    Pvetor=[Pvetor; Pfinal];

    i=i+1;
end


figure(1)
plot(Tfvetor,Pvetor,'-r')
xlabel('Temperatura (Farenheit)')
ylabel('Pressao (psia)')
hold on
line([200,400],[420,420])

figure(2)
plot(Tfvetor,Xvetor(:,1),'-b')
hold on
plot(Tfvetor,Xvetor(:,2),'-r')
plot(Tfvetor,Xvetor(:,3),'-k')
plot(Tfvetor,Xvetor(:,4),'-y')
xlabel('Temperatura (Farenheit)')
ylabel('Composicao')
legend('Comp 1','Comp 2', 'Comp 3', 'Comp 4')
  