function [f] = fncex2(P,par)

%Valores especificados:
Tf=par(1); 
z1=par(2);  
z2=par(3);  
z3=par(4); 
z4=1-z1-z2-z3; % composicao da alimentacao
x1=z1; % composicao 
x2=z2; % composicao 
x3=z3; % composicao
x4=z4; % composicao


% 1) Estimativas para y:

y1velho=0.10;
y2velho=0.20;
y3velho=0.30;
y4velho=1-y1velho-y2velho-y3velho;


%Inicializa erro:
erro=2;

while (erro>0.01),
        
	
	% 2) 
	% Assumindo valores de k(t,p):
	
	% Pela Equacao de Antoine (eq 4-69, pag 159):
	% (valores de Pc do apendice 1, parte A, pag 715)
	% (valores de A1, A2, A3 do apendice 1, parte B, pag 720)
    % (temperatura em Farenheit)
    % (pressao em psia)
	A1=5.383894   ; A2=2847.921    ; A3=434.898    ; Pc=709.8  ; T=Tf;  %Substancia 48
	divisao=exp( A1 - ( A2/(T+A3)  )  );
	Ps1=Pc*divisao;
	
	A1=5.353418   ; A2=3371.084    ; A3=414.488    ; Pc=617.4  ; T=Tf;  %Substancia 64
	divisao=exp( A1 - ( A2/(T+A3)  )  );
	Ps2=Pc*divisao;
	
	A1= 5.741624   ; A2=4126.385    ; A3=409.5179   ; Pc=550.7  ; T=Tf;   %Substancia 87
	divisao=exp( A1 - ( A2/(T+A3)  )  );
	Ps3=Pc*divisao;
	
	A1=5.853654   ; A2=4598.287    ; A3=394.4148    ; Pc=489.5  ; T=Tf;    %Substancia 104
	divisao=exp( A1 - ( A2/(T+A3)  )  );
	Ps4=Pc*divisao;
	
	
	% Pela Lei de Raoult (eq 4-75, pag 161):
	k1=Ps1/P;
	k2=Ps2/P;
	k3=Ps3/P;
	k4=Ps4/P;
	
	
	
	% 3)
	% Calculo de y:
	y1=k1*z1;
	y2=k2*z2;
	y3=k3*z3;
	y4=k4*z4;
	
    % 4)
	% Normaliza:
	y1n=y1/(y1+y2+y3+y4);
	y2n=y2/(y1+y2+y3+y4);
	y3n=y3/(y1+y2+y3+y4);
	y4n=y4/(y1+y2+y3+y4);
    
    y1=y1n;
    y2=y2n;
    y3=y3n;
    y4=y4n;
    
    
    
    % Calculo do erro:
     erro1=abs(y1velho-y1);
     erro2=abs(y2velho-y2);
     erro3=abs(y3velho-y3);
     erro4=abs(y4velho-y4);
     erro=erro1+erro2+erro3+erro4;
     
     y1velho=y1;
     y2velho=y2;
     y3velho=y3;
     y4velho=y4;
     
     % resultado desse loop:
     Y=[y1velho, y2velho, y3velho, y4velho];
 end
 
 save resultado Y; %salva o resultado final
 
 % 5)Calcula f(O) (eq 7.18)
  f= 1 - ( (z1*k1)+(z2*k2)+(z3*k3)+(z4*k4) );
  
  